
##### check if GLIBC >= 2.1 compatible backtrace facility exists

if ( CMAKE_MAJOR_VERSION LESS "3" )
  check_symbol_exists( backtrace "execinfo.h" HAVE_BACKTRACE )
  if ( HAVE_BACKTRACE )
    set ( Backtrace_LIBRARY "" CACHE STRING "Library providing backtrace(3), empty for default set of libraries" )
    set ( Backtrace_HEADER "execinfo.h" CACHE STRING "Header providing backtrace(3) facility" )
  endif ()
else ()
  find_package( Backtrace )
  if ( Backtrace_FOUND )
    set ( HAVE_BACKTRACE 1 CACHE INTERNAL "" )
  endif ()
endif ()
if( NOT HAVE_BACKTRACE )
  tde_message_fatal( "bactrace function is required but not available on your system")
endif()
